print"""
Rob Salgado (rsalgado@mtholyoke.edu)
(shown at AAPT09Sum-AnnArbor)

http://www.visualrelativity.com/vpython/
(old: http://physics.syr.edu/~salgado/software/vpython/ )

07/24/2009

this will
INTERFACE with MULTIPLE WIIMOTES,
SLEEP, CALIBRATE, GRAPH, then WRITE A CSV file of the
CALIBRATED-ACCELEROMETER DATA ( raw - sampled-average )
"""

tmax=3
maxdata=200
filedata=500
thickness=0 #.02

from visual import*
from visual.graph import *   #I use some fancy hacks

############################################################
############################################################
##########
##########
## 
## 
##              #        #
## 
## ###     ######      ###
##  #   #   #   #        #
##   # # # #    #        #
##   # # # #    #        #
##    #   #  #######  #######

import clr                #Brian Lloyd's Python for .NET (Python.Runtime.dll and clr.pyd) 
from WiimoteLib import *  #Brian Peek's WiimoteLib.dll  

import threading
import time

class wiimoteThread ( threading.Thread ):
    
    def __init__ (self):
        threading.Thread.__init__(self)
        self.control=True

        #wm = clr.WiimoteLib.Wiimote() #for just one wiimote
        self.mWC = clr.WiimoteLib.WiimoteCollection()
        self.mWC.FindAllWiimotes()

        self.count=0    #will hold the number of found Wiimotes

        #setup the wiimotes that were found
        print "Seeking Wiimotes...\nFound..."
        for wm in self.mWC:
            wm.Connect()
            wm.SetReportType(clr.WiimoteLib.InputReport.IRAccel, True)
            wm.SetLEDs(false,false,false,false)
            self.count +=1
            print "%d (%2.0f%%)" % (self.count, wm.WiimoteState.Battery) 

    def datalink(self):
        self.Avec=zeros( (self.count,3), Float )
        return self.Avec

    def calibrate(self,sz=1000):
        n=0
        accel=zeros( (self.count,sz,3), Float )
        ta=time.time()
        while n<sz:
            nwm=0
            for wm in self.mWC:
                accel[nwm,n]=array( [
                    wm.WiimoteState.AccelState.Values.X,
                    wm.WiimoteState.AccelState.Values.Y,
                    wm.WiimoteState.AccelState.Values.Z ])
                #print accel[nwm,n]
                nwm +=1
            n+=1
        tb=time.time()
        self.accel_avg=sum(accel,axis=1)/sz
        #accel_std=sqrt(  sum(accel*accel,axis=1)/sz - accel_avg*accel_avg  )
        accel_sumsq=sum(accel*accel,axis=1)/sz 
        #print self.accel_avg
        variance= accel_sumsq - self.accel_avg*self.accel_avg
        #print variance
        self.accel_std=sqrt( abs(variance) ) #sometimes very-small roundoff yields tiny negative
        #print self.accel_std
        return (self.accel_avg,self.accel_std,tb-ta,sz)

    def stop(self):
        self.control=False
         
    def run(self):
        #global ax,ay,az
        while self.control==True:
            rate(300)
            #rate(100)
            wmc=0
            for wm in self.mWC:
                self.Avec[wmc,0]=wm.WiimoteState.AccelState.Values.X
                self.Avec[wmc,1]=wm.WiimoteState.AccelState.Values.Y
                self.Avec[wmc,2]=wm.WiimoteState.AccelState.Values.Z
                wmc +=1
        wmc=0 #at this point, thread was stopped
        for wm in self.mWC:
            self.Avec[wmc,0]=0
            self.Avec[wmc,1]=0
            self.Avec[wmc,2]=0
            wmc +=1

    ####################################################
    ####################################################
            

wiiThread=wiimoteThread()
Avec=wiiThread.datalink()
wiiThread.start()  #Avec will be continually updated by the thread
wiicount=wiiThread.count

##########
##########
############################################################
############################################################


############################################################
############################################################
##########
##########
##
##     ###     #                        ###
##       #                                #
##  #### #   ###      #####  ## ####      #      #####  ###   ###  #####
## ##   ##     #     #    #   ##   ##     #          #    #   #   #    #
## #     #     #      ####    #     #     #      #####    #  #     ####
## ##   ##     #     ##   #   ##   ##     #     #    #     ###    ##   #
##  #### ## #######  #####    # ####   #######   ######     #     #####
##                            #                            #
##                           ####                       ####

# color scheme
#
BW=0
if BW==0:
    fgcolor=color.black; bgcolor=color.white
else:
    fgcolor=color.white; bgcolor=color.black
b1color=color.red
b2color=(0,.75,0)

#
# kinematic graphs
#

def RGBtuple(N):
    palette=[color.red,(0,.5,0),color.blue,color.magenta,color.black]
    return palette[N] 
    
acc_graph=[]

acc_graph.append(gdisplay(x=0, y=00, width=750, height=200, 
             title='x-Acceleration vs. Time', xtitle='t(s)', ytitle='ax (m/s^2)', 
             xmax=tmax, xmin=0,
             ymax=1.1, ymin=-1.1, 
             foreground=fgcolor, background=bgcolor ))
acc_graph.append(gdisplay(x=0, y=200, width=750, height=200, 
             title='y-Acceleration vs. Time', xtitle='t(s)', ytitle='ay (m/s^2)', 
             xmax=tmax, xmin=0,
             ymax=1.1, ymin=-1.1, 
             foreground=fgcolor, background=bgcolor ))
acc_graph.append(gdisplay(x=0, y=400, width=750, height=200, 
             title='z-Acceleration vs. Time', xtitle='t(s)', ytitle='az (m/s^2)', 
             xmax=tmax, xmin=0,
             ymax=1.1, ymin=-1.1, 
             foreground=fgcolor, background=bgcolor ))

for ag in acc_graph:
    ag.acc_Plot=[]

for ag in acc_graph:
    for i in range( wiicount ):
        ag.acc_Plot.append( gcurve(gdisplay=ag, color=RGBtuple(i)))
        ag.acc_Plot[-1].gcurve.radius=thickness
    ag.msg=label(display=ag.display,pos=(tmax/2.,ag.minmax[1][1]/2.),
        text="prepare to calibrate",color=color.red,opacity=0)
############################################################
############################################################

    
print "\nI will wait 2 seconds, then I will Calibrate (do not disturb)"
time.sleep(5)

for ag in acc_graph:
    ag.msg.text="calibrating"

print "\nCalibrating..."
(Aavg,Astd,tcalib,ncalib)=wiiThread.calibrate(1000)
print "Calibration:\n", "avg=",Aavg,"\nstd=",Astd

print "size=",size(Aavg,0)

filedata_csv=zeros( (filedata,1+3*wiicount), Float )


for ag in acc_graph:
    ag.msg.visible=0

print "Counting down to start......................................."
for i in arange(5,0,-1):
    print 50*("%d" %i)
    #time.sleep(1)



############################################################
############################################################

print "Starting at t=0..................................................."
t0=time.time()
t=t0-t0

counter=0; csvdone=0
maxflag=0
while 1:  #run for tmax seconds
    rate(maxdata)

    tprev=t
    ###### get the data point
    t=time.time()-t0
    dt=t-tprev
    acc_graph[0].data_pt=Avec[:,0]-Aavg[:,0] #get calibrated X-data
    acc_graph[1].data_pt=Avec[:,1]-Aavg[:,1] #get calibrated Y-data
    acc_graph[2].data_pt=Avec[:,2]-Aavg[:,2] #get calibrated Z-data

    #data_pt=where( abs(data_raw) > 3*Astd[:,1], data_raw, 0 ) #ignore noise
    #data_pt=data_raw

    filedata_csv[counter,0]=t
    for i in range(wiicount):
        filedata_csv[counter,1+3*i+0]=acc_graph[0].data_pt[i]
        filedata_csv[counter,1+3*i+1]=acc_graph[1].data_pt[i]
        filedata_csv[counter,1+3*i+2]=acc_graph[2].data_pt[i]

    if maxflag==0:
        for ag in acc_graph:
            for i in range( wiicount ):
                ag.acc_Plot[i].plot(pos=(t,ag.data_pt[i]))
    else:
        for ag in acc_graph:
            for i in range( wiicount ):
                temp=ag.acc_Plot[i].gcurve.x-dt
                ag.acc_Plot[i].gcurve.x[0:-1]=temp[1:]
                temp=ag.acc_Plot[i].gcurve.y
                ag.acc_Plot[i].gcurve.y[0:-1]=temp[1:]
                ag.acc_Plot[i].gcurve.x[-1]=0
                ag.acc_Plot[i].gcurve.y[-1]=ag.data_pt[i]

    if maxflag==0 and t>=1.1*tmax: 
        maxflag=1
        for ag in acc_graph:
            for i in range( wiicount ):
                ag.acc_Plot[i].gcurve.x[:] -=t
            ag.minmax[0][1]=0
            ag.autoscale[0]=1
            ag.resize(-t,0)

    if counter<filedata-1:
        counter +=1
    elif csvdone==0:
        print "counter=",  counter

        print "writing file..."
        f=open("acceldata-calib.txt","w")
        f.write("#%s\n" %  time.asctime(time.localtime()) )
        f.write("%s %s\n" %("Aavg=", Aavg) )
        f.write("%s %s\n" %("Astd=", Astd) )
        f.write("%s %6.4e\n" %("tcalib=", tcalib) )
        f.write("%s %d\n" %("ncalib=", ncalib) )
        
        f.write("\n")
        f.close()
        
        f=open("acceldata.csv","w")
        for i in arange(counter):
            f.write("%10.8f" % filedata_csv[i,0])
            for j in arange(3*wiicount):
                f.write(", %10.8f" % filedata_csv[i,j+1])
            f.write("\n")
        f.close()
        print "...done"
        csvdone=1
        
############################################################
############################################################


