# accelerometer-model-threaded-Wiimotelib17-PY25.py

print"""
Rob Salgado (rsalgado@mtholyoke.edu)
(shown at AAPT09Sum-AnnArbor)

http://www.visualrelativity.com/vpython/
(old: http://physics.syr.edu/~salgado/software/vpython/ )

## threaded
## NEED TO VERIFY THE GEOMETRY AND COORDINATE SYSTEMS
"""


from visual import *

##########
##########
import clr                #Brian Lloyd's Python for .NET (Python.Runtime.dll and clr.pyd) 
from WiimoteLib import *  #Brian Peek's WiimoteLib.dll   

import threading
import time

ax=ay=az=0
class wiimoteThread ( threading.Thread ):
    
    def __init__ (self,ACCELvec):
        threading.Thread.__init__(self)

        self.wm = clr.WiimoteLib.Wiimote() #for just one wiimote

        self.count=0
        self.ACCELvec=ACCELvec

        #setup the wiimote that was found
        self.wm.Connect()
        self.wm.SetReportType(clr.WiimoteLib.InputReport.IRAccel, True)
        self.wm.SetLEDs(false,false,false,false)

    def run(self):
        #global ax,ay,az
        while True:
            rate(50)
            self.ACCELvec[0]=self.wm.WiimoteState.AccelState.Values.X
            self.ACCELvec[1]=self.wm.WiimoteState.AccelState.Values.Y
            self.ACCELvec[2]=self.wm.WiimoteState.AccelState.Values.Z


Avec=vector(0,0,0)
wiimoteThread(Avec).start()  #Avec will be continually updated by the thread
##########
##########

title="Accelerometer frame"
scene=display(x=0,y=0,height=400,width=400)
scene.title=title
scene.forward=vector(-1,-1.3,-1)

scene.up=vector(0,0,1)
scene.autoscale=0
scene.range=(2,2,2)
scene.background=color.white
scene.range=(2,2,2)
scene.autoscale=0

scene2=display(x=400,y=0,height=400,width=400)
scene2.forward=vector(-1,-1,-1)
scene2.up=vector(0,0,1)
scene2.autoscale=0
scene2.range=(2,2,2)
scene2.background=color.white
scene2.range=(2,2,2)
scene2.autoscale=0
scene2.title="Earth frame"


scene.select()






ACCframe=frame( )
wiiaxisframe=frame(display=scene2,axis=(0,1,0))
#wiicontroller=box(frame=wiiaxisframe,axis=vector(1,0,0),length=1, width=1.5,height=6  )
wiimotebody=box(display=scene2,frame=wiiaxisframe,axis=vector(0,1,0),length=1.5, width=.325,height=.3  )
wiimote1=cylinder(display=scene2,frame=wiiaxisframe,pos=vector(0.325/2.,.375,0),radius=0.04,length=0.025, color=color.black  )
wiimote2=cylinder(display=scene2,frame=wiiaxisframe,pos=vector(0.325/2.,.510,0),radius=0.04,length=0.025, color=color.black  )
wiimoteud=box(display=scene2,frame=wiiaxisframe,pos=vector(0.325/2.,-.45,0),axis=(0,1,0), length=0.17,width=0.05,height=0.025, color=color.black )
wiimotelr=box(display=scene2,frame=wiiaxisframe,pos=vector(0.325/2.,-.45,0),axis=(0,1,0), width=0.17,length=0.05,height=0.025, color=color.black )
wiimotecam=box(display=scene2,frame=wiiaxisframe,pos=vector(0.325/4.,-.75,0),axis=(0,1,0), width=0.17,length=0.05,height=0.05, color=color.black )
wiimoteB=box(display=scene2,frame=wiiaxisframe,pos=vector(-0.325/4.,-.25,0),axis=(1,1,0), length=0.17,width=0.1,height=0.25, color=color.black )


curve(frame=ACCframe,pos=[(-1,-1,-1),(1,-1,-1),(1,1,-1),(-1,1,-1),(-1,-1,-1)],color=color.black)
curve(frame=ACCframe,pos=[(-1,-1, 1),(1,-1, 1),(1,1, 1),(-1,1, 1),(-1,-1, 1)],color=color.blue,radius=0.02)
curve(frame=ACCframe,pos=[(1,-1,-1 ),(1,1,-1),(1,1, 1),(1,-1,1),(1,-1,-1)],color=color.red,radius=0.02)
curve(frame=ACCframe,pos=[(-1 ,1,-1),(-1,1,1),(1,1, 1),(1,1,-1),(-1,1,-1)],color=color.green,radius=0.02)
curve(frame=ACCframe,pos=[(-1,-1, -1),(-1,-1, 1)],color=color.black)
curve(frame=ACCframe,pos=[( 1,-1, -1),( 1,-1, 1)],color=color.blue)
curve(frame=ACCframe,pos=[( 1, 1, -1),( 1, 1, 1)],color=color.red)
curve(frame=ACCframe,pos=[(-1, 1, -1),(-1, 1, 1)],color=color.blue)
bob=sphere(frame=ACCframe,pos=(0,0,0),radius=0.2,color=color.magenta)
springs=[]

springs.append( helix(frame=ACCframe,pos=vector(-1,-1,-1),axis=bob.pos-vector(-1,-1,-1),radius=0.1,thickness=0.015,color=color.blue) )
springs.append( helix(frame=ACCframe,pos=vector(-1,-1, 1),axis=bob.pos-vector(-1,-1, 1),radius=0.1,thickness=0.015,color=color.blue) )
springs.append( helix(frame=ACCframe,pos=vector(-1, 1,-1),axis=bob.pos-vector(-1, 1,-1),radius=0.1,thickness=0.015,color=color.blue) )
springs.append( helix(frame=ACCframe,pos=vector(-1, 1, 1),axis=bob.pos-vector(-1, 1, 1),radius=0.1,thickness=0.015,color=color.blue) )
springs.append( helix(frame=ACCframe,pos=vector( 1,-1,-1),axis=bob.pos-vector( 1,-1,-1),radius=0.1,thickness=0.015,color=color.blue) )
springs.append( helix(frame=ACCframe,pos=vector( 1,-1, 1),axis=bob.pos-vector( 1,-1, 1),radius=0.1,thickness=0.015,color=color.blue) )
springs.append( helix(frame=ACCframe,pos=vector( 1, 1,-1),axis=bob.pos-vector( 1, 1,-1),radius=0.1,thickness=0.015,color=color.blue) )
springs.append( helix(frame=ACCframe,pos=vector( 1, 1, 1),axis=bob.pos-vector( 1, 1, 1),radius=0.1,thickness=0.015,color=color.blue) )

#arrow(frame=ACCframe,color=color.red,  axis=vector(1,0,0),shaftwidth=0.02, fixedwidth=1)
#arrow(frame=ACCframe,color=color.green,axis=vector(0,1,0),shaftwidth=0.02, fixedwidth=1)
#arrow(frame=ACCframe,color=color.blue, axis=vector(0,0,1),shaftwidth=0.02, fixedwidth=1)

arrow(display=scene2,color=color.red,axis=vector(1,0,0))
arrow(display=scene2,color=color.green,axis=vector(0,1,0))
arrow(display=scene2,color=color.blue,axis=vector(0,0,1))

A=arrow(frame=ACCframe,color=color.black, axis=vector(0,0,1),shaftwidth=0.08, fixedwidth=1)

acc_label=label(display=scene, pos=(0,0,1.4), text='ax,ay,az', opacity=0, color=color.black,height=16 , font='Courier New Bold')
att_label=label(display=scene2, pos=(0,0,1.4), text='ax,ay,az', opacity=0, color=color.black,height=16 , font='Courier New Bold')



    
while 1:
    rate(20)


    ax=Avec[0]
    ay=Avec[1]
    az=Avec[2]
    bob.pos= - vector(
        ax,
        ay,
        az
        )
    A.pos=bob.pos
    A.axis=-bob.pos
    if mag2(A.axis)<1e-2:
        scene.background=color.orange
    else:
        scene.background=color.white

    acc_label.text="%+5.3f   %+5.3f   %+5.3f  (%5.3f)" % (ax,ay,az, mag(A.pos))
    att_label.text="%+5.3f   %+5.3f   %+5.3f" % (-ax,-ay,az)
    scene.title = "%s %+5.3f %+5.3f %+5.3f" % (title,ax,ay,az)
    #scene2.title = "%5.3f" % wm.WiimoteState.Battery


    ### NEED TO VERIFY THE GEOMETRY AND COORDINATE SYSTEMS
    wiiaxisframe.axis= vector(
        -ax,
        -ay,
        az
        )

    #partially-successful hack to correct possible problem in frame()
    if (dot(wiiaxisframe.axis,vector(0,0,1))>=0):
        wiiaxisframe.up=vector(0,1,0)
    else:
        wiiaxisframe.up=-vector(0,1,0)
        

    for s in springs:
        s.axis=bob.pos-s.pos
