# headtrack-Wiimotelib17-PY25.py

print"""
Rob Salgado (rsalgado@mtholyoke.edu) and Tav Hawkins (thawkins@mtholyoke.edu)
version July 12, 2009 (Wiimotelib 1.7/Python.NET2.0 and Python 2.5)
version June 20, 2008 (Wiimotelib 1.2.1/Python.NET1.0 and Python 2.4)
(shown at AAPT09Sum-AnnArbor)

http://www.visualrelativity.com/vpython/
(old: http://physics.syr.edu/~salgado/software/vpython/ )

Inspired by Johnny Chung Lee's Headtracking project at 
http://johnnylee.net/projects/wii/
(old: http://www.cs.cmu.edu/~johnny/projects/wii/ )
"""


from visual import *
from random import *
import clr                #Brian Lloyd's Python for .NET (Python.Runtime.dll and clr.pyd) 
from WiimoteLib import *  #Brian Peek's WiimoteLib.dll   

wm = clr.WiimoteLib.Wiimote() #for just one wiimote

wm.Connect()
wm.SetReportType(clr.WiimoteLib.InputReport.IRAccel, True)
wm.SetLEDs(false,false,false,false);
scene.title += " (Battery %f)" % wm.WiimoteState.Battery

#####################################################
#####################################################
#####################################################

### for debugging the tracking 
scene2=display(x=600,y=0,autoscale=0,range=(1.5,1.5,1.5),fov=1e-10,forward=(0,0,1),title="mirror image of what the Wiimote sees" )
box(axis=(0,0,.07), width=1,height=1)
box(axis=(0,0,.05), width=2,height=2, color=color.yellow)
IRloc=[]
IRloc.append(sphere(radius=.05,color=color.red))
IRloc.append(sphere(radius=.05,color=color.blue))
IRlabel=label(opacity=0,text="IR",pos=(1,-1,0))
scene.select()
###

scene.x=0
scene.y=0
scene.width=600
scene.height=600

#scene.fullscreen=1
scene.autoscale=0
scene.range=(10,10,10)
#scene.stereo='yellowblue'

myIR=[]
myIR.append( sphere(radius=0.2,pos=(0,0,0),color=color.red   ))
myIR.append( sphere(radius=0.2,pos=(0,0,0),color=color.blue  ))


S=20
SZ=10
R=0.1
for j in arange(-S,S,2*S/10):
    curve(pos=[vector(j,-S,S*SZ), vector(j,-S,-S*SZ)],radius=R)
    curve(pos=[vector(j,S,S*SZ), vector(j,S,-S*SZ)],radius=R)
    curve(pos=[vector(-S,j,S*SZ), vector(-S,j,-S*SZ)], radius=R);
    curve(pos=[vector(S,j,S*SZ), vector(S,j,-S*SZ)],radius=R)
    
    curve(pos=[vector(-S,S,j*SZ), vector(S,S,j*SZ)],radius=R)
    curve(pos=[vector(-S,-S,j*SZ), vector(S,-S,j*SZ)],radius=R)
    curve(pos=[vector(-S,-S,j*SZ), vector(-S,S,j*SZ)],radius=R)
    curve(pos=[vector(S,-S,j*SZ), vector(S,S,j*SZ)],radius=R)

    curve(pos=[vector(j,-S,-S*SZ), vector(j,S,-S*SZ)],radius=R)
    curve(pos=[vector(-S,j,-S*SZ), vector(S,j,-S*SZ)],radius=R)


N=25
disk=[]
stick=[]
sq=[]
for i in range(N):
         disk+=[cylinder(axis=vector(0,0,.1),
             pos=(uniform(-S/2.,S/2.),uniform(-S/2.,S/2.),uniform(-S/2.,S/2.)),radius=3*random(),
            color=(random(),random(),random()))]
         disk+=[cylinder(axis=vector(0,0,.2),
             pos=disk[-1].pos,radius=disk[-1].radius*0.75,
            color=( 1-disk[-1].color[0], 1-disk[-1].color[1], 1-disk[-1].color[2] ))]
         stick+=[curve( pos=[ vector(disk[-1].x, disk[-1].y, -S*SZ), disk[-1].pos+vector(0,0,.7) ], radius=disk[-1].radius/5.,
                        color=disk[-1].color )] 



IRscale=2.0
IRcenter= vector(1/2.,1/2.,0)

refD=2

def newEYE(A,B):
    #crude method to headtrack
    M=(A+B)/2.
    D1=B-A

    if mag(D1)>1.e-1:
        EYEz=refD/mag(D1)
    else:
        EYEz=refD/1.e-1  

    EYEplane=M

    scene.center[2]=EYEz
    scene.forward=vector( EYEplane[0],-EYEplane[1], -1 )


zeroV=vector(0,0,0)



while True:
    IRcount=0
    rate(50)

    if wm.WiimoteState.IRState.IRSensors[0].Found:
        IRcount+=1
        myIR[0].pos=IRscale* ( (vector(
            wm.WiimoteState.IRState.IRSensors[0].Position.X,
            wm.WiimoteState.IRState.IRSensors[0].Position.Y
            ))-IRcenter )
        myIR[0].radius=.01   #+log(WII.IRState.Size1/100.+1)
        myIR[0].visible=1
    else:
        myIR[0].visible=0
        
    if wm.WiimoteState.IRState.IRSensors[1].Found:
        IRcount+=1

        myIR[1].pos=IRscale*( (vector(
            wm.WiimoteState.IRState.IRSensors[1].Position.X,
            wm.WiimoteState.IRState.IRSensors[1].Position.Y
            ))-IRcenter )
        myIR[1].radius=.01  #+log(WII.IRState.Size2/100.+1)
        myIR[1].visible=1
    else:
        myIR[1].visible=0

    IRloc[0].visible=myIR[0].visible
    IRloc[1].visible=myIR[1].visible

    newEYE(myIR[0].pos, myIR[1].pos)

        
    IRloc[0].pos=myIR[0].pos
    IRloc[1].pos=myIR[1].pos
    IRlabel.text="%d" % IRcount
