### wiimote_headtrack_thread.py
##
print"""
Rob Salgado (rsalgado@mtholyoke.edu) and Tav Hawkins (thawkins@mtholyoke.edu)
version July 12, 2009 (Wiimotelib 1.7/Python.NET2.0 and Python 2.5)
version June 20, 2008 (Wiimotelib 1.2.1/Python.NET1.0 and Python 2.4)
(shown at AAPT09Sum-AnnArbor)

http://www.visualrelativity.com/vpython/
(old: http://physics.syr.edu/~salgado/software/vpython/ )

Inspired by Johnny Chung Lee's Headtracking project at 
http://johnnylee.net/projects/wii/
(old: http://www.cs.cmu.edu/~johnny/projects/wii/ )
"""
##
##
from visual import *
##from random import *

##########
##########
import clr                #Brian Lloyd's Python for .NET (Python.Runtime.dll and clr.pyd) 
from WiimoteLib import *  #Brian Peek's WiimoteLib.dll  

import threading
import time

class wiimoteThread ( threading.Thread ):
    
    def __init__ (self,L,R):
        threading.Thread.__init__(self)

        self.wm = clr.WiimoteLib.Wiimote() #for just one wiimote
        self.L=L
        self.R=R

        #setup the wiimote that were found
              
        self.wm.Connect()
        self.wm.SetReportType(clr.WiimoteLib.InputReport.IRAccel, True)
        self.wm.SetLEDs(false,false,false,false)

    def run(self):
        #global ax,ay,az
        while True:
            rate(20)
            self.L[0]=self.wm.WiimoteState.IRState.IRSensors[0].Found
            self.L[1]=self.wm.WiimoteState.IRState.IRSensors[0].Position.X
            self.L[2]=self.wm.WiimoteState.IRState.IRSensors[0].Position.Y
            self.R[0]=self.wm.WiimoteState.IRState.IRSensors[1].Found
            self.R[1]=self.wm.WiimoteState.IRState.IRSensors[1].Position.X
            self.R[2]=self.wm.WiimoteState.IRState.IRSensors[1].Position.Y




class forwardThread ( threading.Thread ):    
    def __init__ (self,scene,L,R):
        threading.Thread.__init__(self)

        self.scene=scene
        self.L=L
        self.R=R
        self.Lpos=vector(0,0)
        self.Rpos=vector(0,0)

    def run(self):

        IRscale=2.0
        IRcenter= vector(1/2.,1/2.,0)
        
        while True:
            IRcount=0
            rate(20)

            if self.L[0]:
                IRcount+=1
                self.Lpos=IRscale* ( (vector(
                    self.L[1],
                    self.L[2]
                    ))-IRcenter )
                
            if self.R[0]:
                IRcount+=1

                self.Rpos=IRscale*( (vector(
                    self.R[1],
                    self.R[2]
                    ))-IRcenter )

            self.newEYE(self.Lpos, self.Rpos)


    def newEYE(self,A,B):
        #crude method to headtrack
        refD=2
        M=(A+B)/2.
        D1=B-A

        if mag(D1)>1.e-1:
            EYEz=refD/mag(D1)
        else:
            EYEz=refD/1.e-1  

        EYEplane=M

        self.scene.center[2]=EYEz
        self.scene.forward=vector( EYEplane[0],-EYEplane[1], -1 )


if __name__ == "__main__":
    print """
    wiimote_headtrack_thread.py only sets up a thread to control scene.forward
    """

